﻿class Profundidad extends MovieClip
{
	//Propiedades
	var yProf:Number;
	var xProf:Number;
	var easy:Number;
	var objetos_arr:Array;
	
	//Constructor
	public function Profundidad()
	{
		//creamos el array q contiene los MC a mover
		objetos_arr = [];
	}
	
	//Metodos
	public function ini(_objetos_arr:Array, _xProf:Number, _yProf:Number, _easy:Number):Void
	{
		this.yProf = _yProf; //profundida en Y (menor valor mayor profundidad)
		this.xProf = _xProf; //profundida en X (menor valor mayor profundidad)
		this.easy = _easy; //valor del efecto easy (menor valor mayor lentitud)
		this.objetos_arr = _objetos_arr; //Array con los nombres de los MovieClips
		PosActuales(); // Funsion interna q guarda las posiciones iniciales de los MC
		
		this.onEnterFrame = function()
			{
				for (var i:Number = 0; i<objetos_arr.length; i++)
				{
					var obj:Object = objetos_arr[i]; //MC a mover
					var mov:Number = i+1; // valor de movimiento y profundidad
					//movimiento en X
					obj.xPos = (_xmouse-(Stage.width/2))*mov/3; //destino del MC
					obj.xvel = easy/mov; // velocidad del easy segun la profundidad
					obj.xdest = obj["xPosNivIni_"+i] - obj.xPos/xProf; //destino del MC segun profundidad
					obj._x += (obj.xdest-obj._x)/obj.xvel; //calculo de movimiento del MC con easy
					//movimiento en Y, igual al del X
					obj.yPos = (_ymouse-(Stage.height/2))*mov/3;
					obj.yvel = easy/mov;
					obj.ydest = obj["yPosNivIni_"+i]-obj.yPos/yProf;
					obj._y += (obj.ydest-obj._y)/obj.yvel;
				}
			};

	}
	
	private function PosActuales():Void
	{
		//recorre todos los MC y guarda las posiciones iniciales de c/us
		for (var i:Number = 0; i<objetos_arr.length; i++)
			{
				objetos_arr[i]["xPosNivIni_"+i] = objetos_arr[i]._x;
				objetos_arr[i]["yPosNivIni_"+i] = objetos_arr[i]._y;
			}
	}
	
	//Setters y Getters
	
	//cambiamos la profundidad en X
	public function set _xProf(num:Number):Void
	{
		this.xProf = num;
	}
	public function get _xProf():Number
	{
		return this.xProf;
	}
	
	//cambiamos la profundidad en Y
	public function set _yProf(num:Number):Void
	{
		this.yProf = num;
	}
	public function get _yProf():Number
	{
		return this.yProf;
	}
	
	//cambiamos el valor de velocidad del easy
	public function set _easy(num:Number):Void
	{
		this.easy = num;
	}
	public function get _easy():Number
	{
		return this.easy;
	}
	
}